/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"bytes"
	"context"
	"io"
	"net/http"
	"net/url"
	"strings"
	"reflect"
)


// CxTemplatesAPIService CxTemplatesAPI service
type CxTemplatesAPIService service

type ApiGetCxTemplatesIdRequest struct {
	ctx context.Context
	ApiService *CxTemplatesAPIService
	id string
}

func (r ApiGetCxTemplatesIdRequest) Execute() (*CxTemplate, *http.Response, error) {
	return r.ApiService.GetCxTemplatesIdExecute(r)
}

/*
GetCxTemplatesId Get one global

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @param id
 @return ApiGetCxTemplatesIdRequest
*/
func (a *CxTemplatesAPIService) GetCxTemplatesId(ctx context.Context, id string) ApiGetCxTemplatesIdRequest {
	return ApiGetCxTemplatesIdRequest{
		ApiService: a,
		ctx: ctx,
		id: id,
	}
}

// Execute executes the request
//  @return CxTemplate
func (a *CxTemplatesAPIService) GetCxTemplatesIdExecute(r ApiGetCxTemplatesIdRequest) (*CxTemplate, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodGet
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  *CxTemplate
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "CxTemplatesAPIService.GetCxTemplatesId")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/cx-templates/{id}"
	localVarPath = strings.Replace(localVarPath, "{"+"id"+"}", url.PathEscape(parameterValueToString(r.id, "id")), -1)

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiGetOrganizationsOrganizationIdCxTemplatesRequest struct {
	ctx context.Context
	ApiService *CxTemplatesAPIService
	organizationId string
	tags *[]string
	statuses *[]string
	languages *[]string
	formality *string
	global *bool
	shared *bool
}

// Tags filter
func (r ApiGetOrganizationsOrganizationIdCxTemplatesRequest) Tags(tags []string) ApiGetOrganizationsOrganizationIdCxTemplatesRequest {
	r.tags = &tags
	return r
}

func (r ApiGetOrganizationsOrganizationIdCxTemplatesRequest) Statuses(statuses []string) ApiGetOrganizationsOrganizationIdCxTemplatesRequest {
	r.statuses = &statuses
	return r
}

// Languages filter
func (r ApiGetOrganizationsOrganizationIdCxTemplatesRequest) Languages(languages []string) ApiGetOrganizationsOrganizationIdCxTemplatesRequest {
	r.languages = &languages
	return r
}

func (r ApiGetOrganizationsOrganizationIdCxTemplatesRequest) Formality(formality string) ApiGetOrganizationsOrganizationIdCxTemplatesRequest {
	r.formality = &formality
	return r
}

func (r ApiGetOrganizationsOrganizationIdCxTemplatesRequest) Global(global bool) ApiGetOrganizationsOrganizationIdCxTemplatesRequest {
	r.global = &global
	return r
}

func (r ApiGetOrganizationsOrganizationIdCxTemplatesRequest) Shared(shared bool) ApiGetOrganizationsOrganizationIdCxTemplatesRequest {
	r.shared = &shared
	return r
}

func (r ApiGetOrganizationsOrganizationIdCxTemplatesRequest) Execute() (*GetOrganizationsOrganizationIdCxTemplates200Response, *http.Response, error) {
	return r.ApiService.GetOrganizationsOrganizationIdCxTemplatesExecute(r)
}

/*
GetOrganizationsOrganizationIdCxTemplates Get list of organization cx templates

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @param organizationId
 @return ApiGetOrganizationsOrganizationIdCxTemplatesRequest
*/
func (a *CxTemplatesAPIService) GetOrganizationsOrganizationIdCxTemplates(ctx context.Context, organizationId string) ApiGetOrganizationsOrganizationIdCxTemplatesRequest {
	return ApiGetOrganizationsOrganizationIdCxTemplatesRequest{
		ApiService: a,
		ctx: ctx,
		organizationId: organizationId,
	}
}

// Execute executes the request
//  @return GetOrganizationsOrganizationIdCxTemplates200Response
func (a *CxTemplatesAPIService) GetOrganizationsOrganizationIdCxTemplatesExecute(r ApiGetOrganizationsOrganizationIdCxTemplatesRequest) (*GetOrganizationsOrganizationIdCxTemplates200Response, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodGet
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  *GetOrganizationsOrganizationIdCxTemplates200Response
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "CxTemplatesAPIService.GetOrganizationsOrganizationIdCxTemplates")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/organizations/{organization_id}/cx-templates"
	localVarPath = strings.Replace(localVarPath, "{"+"organization_id"+"}", url.PathEscape(parameterValueToString(r.organizationId, "organizationId")), -1)

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	if r.tags != nil {
		t := *r.tags
		if reflect.TypeOf(t).Kind() == reflect.Slice {
			s := reflect.ValueOf(t)
			for i := 0; i < s.Len(); i++ {
				parameterAddToHeaderOrQuery(localVarQueryParams, "tags[]", s.Index(i).Interface(), "multi")
			}
		} else {
			parameterAddToHeaderOrQuery(localVarQueryParams, "tags[]", t, "multi")
		}
	}
	if r.statuses != nil {
		t := *r.statuses
		if reflect.TypeOf(t).Kind() == reflect.Slice {
			s := reflect.ValueOf(t)
			for i := 0; i < s.Len(); i++ {
				parameterAddToHeaderOrQuery(localVarQueryParams, "statuses[]", s.Index(i).Interface(), "multi")
			}
		} else {
			parameterAddToHeaderOrQuery(localVarQueryParams, "statuses[]", t, "multi")
		}
	}
	if r.languages != nil {
		t := *r.languages
		if reflect.TypeOf(t).Kind() == reflect.Slice {
			s := reflect.ValueOf(t)
			for i := 0; i < s.Len(); i++ {
				parameterAddToHeaderOrQuery(localVarQueryParams, "languages[]", s.Index(i).Interface(), "multi")
			}
		} else {
			parameterAddToHeaderOrQuery(localVarQueryParams, "languages[]", t, "multi")
		}
	}
	if r.formality != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "formality", r.formality, "")
	}
	if r.global != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "global", r.global, "")
	}
	if r.shared != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "shared", r.shared, "")
	}
	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiGetOrganizationsOrganizationIdCxTemplatesInstallationsInstallationIdCampaignsRequest struct {
	ctx context.Context
	ApiService *CxTemplatesAPIService
	organizationId string
	installationId string
	interactionId *string
}

func (r ApiGetOrganizationsOrganizationIdCxTemplatesInstallationsInstallationIdCampaignsRequest) InteractionId(interactionId string) ApiGetOrganizationsOrganizationIdCxTemplatesInstallationsInstallationIdCampaignsRequest {
	r.interactionId = &interactionId
	return r
}

func (r ApiGetOrganizationsOrganizationIdCxTemplatesInstallationsInstallationIdCampaignsRequest) Execute() (*GetOrganizationsOrganizationIdCxTemplatesInstallationsInstallationIdCampaigns200Response, *http.Response, error) {
	return r.ApiService.GetOrganizationsOrganizationIdCxTemplatesInstallationsInstallationIdCampaignsExecute(r)
}

/*
GetOrganizationsOrganizationIdCxTemplatesInstallationsInstallationIdCampaigns Get installation campaigns

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @param organizationId
 @param installationId
 @return ApiGetOrganizationsOrganizationIdCxTemplatesInstallationsInstallationIdCampaignsRequest
*/
func (a *CxTemplatesAPIService) GetOrganizationsOrganizationIdCxTemplatesInstallationsInstallationIdCampaigns(ctx context.Context, organizationId string, installationId string) ApiGetOrganizationsOrganizationIdCxTemplatesInstallationsInstallationIdCampaignsRequest {
	return ApiGetOrganizationsOrganizationIdCxTemplatesInstallationsInstallationIdCampaignsRequest{
		ApiService: a,
		ctx: ctx,
		organizationId: organizationId,
		installationId: installationId,
	}
}

// Execute executes the request
//  @return GetOrganizationsOrganizationIdCxTemplatesInstallationsInstallationIdCampaigns200Response
func (a *CxTemplatesAPIService) GetOrganizationsOrganizationIdCxTemplatesInstallationsInstallationIdCampaignsExecute(r ApiGetOrganizationsOrganizationIdCxTemplatesInstallationsInstallationIdCampaignsRequest) (*GetOrganizationsOrganizationIdCxTemplatesInstallationsInstallationIdCampaigns200Response, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodGet
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  *GetOrganizationsOrganizationIdCxTemplatesInstallationsInstallationIdCampaigns200Response
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "CxTemplatesAPIService.GetOrganizationsOrganizationIdCxTemplatesInstallationsInstallationIdCampaigns")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/organizations/{organization_id}/cx-templates-installations/{installation_id}/campaigns"
	localVarPath = strings.Replace(localVarPath, "{"+"organization_id"+"}", url.PathEscape(parameterValueToString(r.organizationId, "organizationId")), -1)
	localVarPath = strings.Replace(localVarPath, "{"+"installation_id"+"}", url.PathEscape(parameterValueToString(r.installationId, "installationId")), -1)

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	if r.interactionId != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "interaction_id", r.interactionId, "")
	}
	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiGetOrganizationsOrganizationIdCxTemplatesInstallationsInstallationIdScriptsRequest struct {
	ctx context.Context
	ApiService *CxTemplatesAPIService
	organizationId string
	installationId string
	interactionId *string
}

func (r ApiGetOrganizationsOrganizationIdCxTemplatesInstallationsInstallationIdScriptsRequest) InteractionId(interactionId string) ApiGetOrganizationsOrganizationIdCxTemplatesInstallationsInstallationIdScriptsRequest {
	r.interactionId = &interactionId
	return r
}

func (r ApiGetOrganizationsOrganizationIdCxTemplatesInstallationsInstallationIdScriptsRequest) Execute() (*GetOrganizationsOrganizationIdCxTemplatesInstallationsInstallationIdScripts200Response, *http.Response, error) {
	return r.ApiService.GetOrganizationsOrganizationIdCxTemplatesInstallationsInstallationIdScriptsExecute(r)
}

/*
GetOrganizationsOrganizationIdCxTemplatesInstallationsInstallationIdScripts Get installation scripts

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @param organizationId
 @param installationId
 @return ApiGetOrganizationsOrganizationIdCxTemplatesInstallationsInstallationIdScriptsRequest
*/
func (a *CxTemplatesAPIService) GetOrganizationsOrganizationIdCxTemplatesInstallationsInstallationIdScripts(ctx context.Context, organizationId string, installationId string) ApiGetOrganizationsOrganizationIdCxTemplatesInstallationsInstallationIdScriptsRequest {
	return ApiGetOrganizationsOrganizationIdCxTemplatesInstallationsInstallationIdScriptsRequest{
		ApiService: a,
		ctx: ctx,
		organizationId: organizationId,
		installationId: installationId,
	}
}

// Execute executes the request
//  @return GetOrganizationsOrganizationIdCxTemplatesInstallationsInstallationIdScripts200Response
func (a *CxTemplatesAPIService) GetOrganizationsOrganizationIdCxTemplatesInstallationsInstallationIdScriptsExecute(r ApiGetOrganizationsOrganizationIdCxTemplatesInstallationsInstallationIdScriptsRequest) (*GetOrganizationsOrganizationIdCxTemplatesInstallationsInstallationIdScripts200Response, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodGet
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  *GetOrganizationsOrganizationIdCxTemplatesInstallationsInstallationIdScripts200Response
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "CxTemplatesAPIService.GetOrganizationsOrganizationIdCxTemplatesInstallationsInstallationIdScripts")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/organizations/{organization_id}/cx-templates-installations/{installation_id}/scripts"
	localVarPath = strings.Replace(localVarPath, "{"+"organization_id"+"}", url.PathEscape(parameterValueToString(r.organizationId, "organizationId")), -1)
	localVarPath = strings.Replace(localVarPath, "{"+"installation_id"+"}", url.PathEscape(parameterValueToString(r.installationId, "installationId")), -1)

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	if r.interactionId != nil {
		parameterAddToHeaderOrQuery(localVarQueryParams, "interaction_id", r.interactionId, "")
	}
	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}

type ApiPostOrganizationsOrganizationIdCxTemplatesRequest struct {
	ctx context.Context
	ApiService *CxTemplatesAPIService
	organizationId string
	cxTemplateCreateData *CxTemplateCreateData
}

func (r ApiPostOrganizationsOrganizationIdCxTemplatesRequest) CxTemplateCreateData(cxTemplateCreateData CxTemplateCreateData) ApiPostOrganizationsOrganizationIdCxTemplatesRequest {
	r.cxTemplateCreateData = &cxTemplateCreateData
	return r
}

func (r ApiPostOrganizationsOrganizationIdCxTemplatesRequest) Execute() (*CxTemplate, *http.Response, error) {
	return r.ApiService.PostOrganizationsOrganizationIdCxTemplatesExecute(r)
}

/*
PostOrganizationsOrganizationIdCxTemplates Create cx template

 @param ctx context.Context - for authentication, logging, cancellation, deadlines, tracing, etc. Passed from http.Request or context.Background().
 @param organizationId
 @return ApiPostOrganizationsOrganizationIdCxTemplatesRequest
*/
func (a *CxTemplatesAPIService) PostOrganizationsOrganizationIdCxTemplates(ctx context.Context, organizationId string) ApiPostOrganizationsOrganizationIdCxTemplatesRequest {
	return ApiPostOrganizationsOrganizationIdCxTemplatesRequest{
		ApiService: a,
		ctx: ctx,
		organizationId: organizationId,
	}
}

// Execute executes the request
//  @return CxTemplate
func (a *CxTemplatesAPIService) PostOrganizationsOrganizationIdCxTemplatesExecute(r ApiPostOrganizationsOrganizationIdCxTemplatesRequest) (*CxTemplate, *http.Response, error) {
	var (
		localVarHTTPMethod   = http.MethodPost
		localVarPostBody     interface{}
		formFiles            []formFile
		localVarReturnValue  *CxTemplate
	)

	localBasePath, err := a.client.cfg.ServerURLWithContext(r.ctx, "CxTemplatesAPIService.PostOrganizationsOrganizationIdCxTemplates")
	if err != nil {
		return localVarReturnValue, nil, &GenericOpenAPIError{error: err.Error()}
	}

	localVarPath := localBasePath + "/organizations/{organization_id}/cx-templates"
	localVarPath = strings.Replace(localVarPath, "{"+"organization_id"+"}", url.PathEscape(parameterValueToString(r.organizationId, "organizationId")), -1)

	localVarHeaderParams := make(map[string]string)
	localVarQueryParams := url.Values{}
	localVarFormParams := url.Values{}

	// to determine the Content-Type header
	localVarHTTPContentTypes := []string{"application/json"}

	// set Content-Type header
	localVarHTTPContentType := selectHeaderContentType(localVarHTTPContentTypes)
	if localVarHTTPContentType != "" {
		localVarHeaderParams["Content-Type"] = localVarHTTPContentType
	}

	// to determine the Accept header
	localVarHTTPHeaderAccepts := []string{"application/json"}

	// set Accept header
	localVarHTTPHeaderAccept := selectHeaderAccept(localVarHTTPHeaderAccepts)
	if localVarHTTPHeaderAccept != "" {
		localVarHeaderParams["Accept"] = localVarHTTPHeaderAccept
	}
	// body params
	localVarPostBody = r.cxTemplateCreateData
	req, err := a.client.prepareRequest(r.ctx, localVarPath, localVarHTTPMethod, localVarPostBody, localVarHeaderParams, localVarQueryParams, localVarFormParams, formFiles)
	if err != nil {
		return localVarReturnValue, nil, err
	}

	localVarHTTPResponse, err := a.client.callAPI(req)
	if err != nil || localVarHTTPResponse == nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	localVarBody, err := io.ReadAll(localVarHTTPResponse.Body)
	localVarHTTPResponse.Body.Close()
	localVarHTTPResponse.Body = io.NopCloser(bytes.NewBuffer(localVarBody))
	if err != nil {
		return localVarReturnValue, localVarHTTPResponse, err
	}

	if localVarHTTPResponse.StatusCode >= 300 {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: localVarHTTPResponse.Status,
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	err = a.client.decode(&localVarReturnValue, localVarBody, localVarHTTPResponse.Header.Get("Content-Type"))
	if err != nil {
		newErr := &GenericOpenAPIError{
			body:  localVarBody,
			error: err.Error(),
		}
		return localVarReturnValue, localVarHTTPResponse, newErr
	}

	return localVarReturnValue, localVarHTTPResponse, nil
}
